=== navit/graphics/gtk_drawing_area/CMakeLists.txt ===
set(graphics_gtk_drawing_area_LIBS ${IMLIB2_LDFLAGS} ${GTK2_LIBRARIES})
module_add_library(graphics_gtk_drawing_area graphics_gtk_drawing_area.c)
