=== navit/gui/win32/CMakeLists.txt ===
module_add_library(gui_win32 gui_win32.c win32_gui_destination.c win32_gui_notify.c ceglue.c)
