=== debian/changelog ===
navit (0.5.3+dfsg.1-1) unstable; urgency=low

  * New upstream version 0.5.3+dfsg.1

  * Remove LIBDIR patch integrated by upstream in this version
  * Refresh patches

  * d/control: bump standards to 4.2.1

  * d/watch: Add the .1 usually used with this package to the dfsg suffix
  * Add signature for signed releases
  * Add information in d/u/metadata using DEP-12

 -- Joseph Herlant <herlantj@gmail.com>  Sat, 01 Sep 2018 00:39:56 -0700
