=== debian/watch ===
version=3
# opts=filenamemangle=s/.+\/v?(\d+\.\d+\.\d+)\.tar\.gz/navit-$1\.tar\.gz/ \
opts=pgpsigurlmangle=s/archive\/v(\d\S*)\.tar\.gz/releases\/download\/v$1\/navit-$1.tar.gz.asc/,dversionmangle=s/\+dfsg\.\d*$//,repacksuffix=+dfsg.1 \
https://github.com/navit-gps/navit/releases .*/v?(\d+\.\d+\.\d+)\.tar\.gz
