=== debian/changelog ===
navit (0.5.4+dfsg.1-2) unstable; urgency=medium

  * Drop dependency on librsgv2-bin and switch to inkscape (Closes: #949484)
  * Disable pedestrian plugin as not entirely tested and supported upstream
  * Bump standards to 4.5.0, no further change needed

 -- Joseph Herlant <aerostitch@debian.org>  Tue, 21 Jan 2020 21:33:00 -0800

navit (0.5.4+dfsg.1-1) unstable; urgency=medium

  * New upstream version 0.5.4+dfsg.1 (closes: #948388, #949214)
  * Drop gpsd-7 patch integrated upstream
  * Add patch to fix a build failure due to changes in the pedestrian plugin
  * d/rules: Explicitly disable QT, to fix FTBFS when qtbase5-dev is installed.
    Thanks to Bernhard Übelacker for the fix
  * d/control:
    * add missing build dependencies:
      * protobuf-c-compiler
      * libprotobuf-c-dev
    * move homepage from the deprecated wiki to the new site
    * bump standards to 4.4.1 and debhelper to 12
    * add missing Rules-Requires-Root field
  * d/copyright: simplify and update the copyright files
  * Override lintian library-not-linked-against-libc tag for speech_dispatcher
    as not using any libc flag

 -- Joseph Herlant <aerostitch@debian.org>  Sun, 19 Jan 2020 11:49:33 -0800

navit (0.5.3+dfsg.1-2) unstable; urgency=medium

  * New patch gpsd-7.patch to support the new gps_read implementation
    starting from gpsd GPSD_API_MAJOR_VERSION 7 (closes: #926522)

 -- Gilles Filippini <pini@debian.org>  Mon, 12 Aug 2019 12:36:32 +0200
